$(function () {
    var Softphone = {};

    Softphone.ValueObserver = function () {
        var self = this;

        self.fieldsObservers = {};

        self.initObservers = function () {
            var MutationObserver = window.MutationObserver;
            var config = {
                attributes: true
            };

            var observer = new MutationObserver(function (mutations) {
                if (mutations[0].attributeName == "value") {
                    $(mutations[0].target).trigger('change');
                }
            });

            for (var field in self.fieldsObservers) {
                if ($('#' + field)[0]) {
                    observer.observe($('#' + field)[0], config);
                }
            }

            for (var field in self.fieldsObservers) {
                var functionName = self.fieldsObservers[field];
                self[functionName](field);
            }
        }
    }

    new ClipboardJS('.copy_btn');

    var observer = new Softphone.ValueObserver;
    observer.fieldsObservers = {
        'sip_license_key': 'changeLink',
        'sip_server': 'changeLink',
        'sip_domain': 'changeLink',
        'sip_proxy': 'changeLink',
    };

    observer.changeLink = function (selector) {
        $('#' + selector).on('change keyup', function () {
            var link = $('#distrib_link').val();

            var params = [
                observer._getParam('sip_license_key', 'licenseKey'),
                observer._getParam('sip_server', 'sipServer'),
                observer._getParam('sip_domain', 'sipDomain'),
                observer._getParam('sip_proxy', 'sipProxy')
            ]

            var result = params.filter(word => word.length > 0);

            $('[id^= "visible_url_"').each(function () {
                var counter = $(this).attr('data-counter');
                var temp = [
                    'sipUser=' + $('#ext_' + counter).val(),
                    'sipPwd=' + $('#pass_' + counter).val()
                ];

                var final = result.concat(temp);
                $('#visible_url_' + counter).val(link + final.join('&'));
            });
        })
    };

    observer._getParam = function (selector, key) {
        var value = '';

        if ($('#' + selector)) {
            value = $.trim($('#' + selector).val());
        }

        if (value && value.length) {
            value = key + '=' + value;
        }

        return value;
    }

    observer.initObservers();
});